/*	exscan v0.2
	By PolarRoot (pi9@hotmail.com)
	
	Thanks:		darknite (darknite@kurir.net)
			  for his great article in the Fall 1998: "2600"
*/

// Request Variables
char HTTPREQ[19]  ="HEAD / HTTP/1.0";
char FINGERREQ[2] ="";
// Global Variables
int s;
struct hostent *host;
struct sockaddr_in sock;

#include "main.h"

int argport (int port, int argc, char **argv) {
	int i;

	if (argc==2) return 1;
	for (i=2; i<=argc-1; i++)
		if (atoi(argv[i])==port) return 1;
	return 0;
}

int check_commandline (int argc, char **argv) {
	int i;
	int j;

	// Test for too few arguments
	if (argc < 2) return 1;
	// Test for <hostname>
	for (i=0; i<=strlen(argv[1])-1; i++) {
		if (isalnum(argv[1][i])==0) {
			if (argv[1][i]!='.') return 1;
		}
	}
	// Test for all [port] are numeric
	for (i=2; i<=argc-1; i++) {
		for (j=0; j<=strlen(argv[i])-1; j++) {
			if (isdigit(argv[i][j])==0) {
				if (argv[i][j]!='.') return 1;
			}
		}
	}
	// The command line must be ok!
	return 0;
}

void main (int argc, char **argv) {
	setup();

	printf("exscan - v0.2 - By PolarRoot [pi9@hotmail.com]\n");
	if (check_commandline(argc, argv)) {
		printf("\nUsage:\n");
		printf("\t%s <hostname> [port]\n", argv[0]);
		printf("\t<hostname> - name of target computer (IP or name); required\n");
		printf("\t[port]     - port number(s) to scan; space-delimited list\n\n");
		printf("Examples:\n");
		printf("\t%s 127.0.0.1\n", argv[0]);
		printf("\t%s www.rootshell.com 80\n", argv[0]);
		printf("\t%s www.l0pht.com 23 80 110\n\n", argv[0]);
		exit(0);
	}

	host=gethostbyname(argv[1]);
	if (!host) exit(printf("Error looking up hostname.\n"));

	sock.sin_family = AF_INET;
	sock.sin_addr.s_addr=*(long *)(host->h_addr);

	// Old, crappy code!
	//printf("Scanning Host: %s [%i.%i.%i.%i]\n\n", argv[1], host->h_addr[0], host->h_addr[1], host->h_addr[2], host->h_addr[3]);
	printf("Scanning Host: %s [%s]\n\n", argv[1], inet_ntoa(sock.sin_addr));

	// Scan for port   7 - echo
	if (argport(7, argc, argv)) ScanPort(7, "Echo");
	// Scan for port   9 - discard
	if (argport(9, argc, argv)) ScanPort(9, "Discard");
	// Scan for port  13 - daytime
	if (argport(13, argc, argv)) ScanPort(13, "Daytime");	
	// Scan for port  17 - chargen
	if (argport(17, argc, argv)) ScanPort(17, "Character Generator");
	// Scan for port  19 - quote of the day
	if (argport(19, argc, argv)) ScanPort(19, "Quote of the Day");
	// Scan/data for port  21 - ftp
	if (argport(21, argc, argv)) ScanPortData(21, "File Transfer Protocol");
	// Scan/data for port  23 - telnet
	if (argport(23, argc, argv)) ScanPortData(23, "Telnet");
	// Scan/data for port  25 - smtp
	if (argport(25, argc, argv)) ScanPortData(25, "Simple Mail Transfer Protocol");
	// Scan for port  37 - time
	if (argport(37, argc, argv)) ScanPort(37, "Time");
	// Scan for port  53 - domain name server
	if (argport(53, argc, argv)) ScanPort(53, "Domain Name Server");
	// Scan/data for port  69 - trivial ftp
	if (argport(69, argc, argv)) ScanPortData(69, "Trivial File Transfer Protocol");
	// Scan for port  70 - gopher
	if (argport(70, argc, argv)) ScanPort(70, "Gopher");
	// Scan/query for port  79 - finger
	if (argport(79, argc, argv)) ScanPortQuery(79, "Finger", FINGERREQ);
	// Scan/query for port  80 - http
	if (argport(80, argc, argv)) ScanPortQuery(80, "Hypertext Transfer Protocol", HTTPREQ);
	// Scan/data for port 109 - pop2
	if (argport(109, argc, argv)) ScanPortData(109, "Post Office Protocol 2");
	// Scan/data for port 110 - pop3
	if (argport(110, argc, argv)) ScanPortData(110, "Post Office Protocol 3");
	// Scan/data for port 119 - nntp
	if (argport(119, argc, argv)) ScanPortData(119, "Network News Transfer Protocol");
	// Scan for port 137 - netbios
	if (argport(137, argc, argv)) ScanPort(137, "NetBIOS Name Service");
	// Scan for port 138 - netbios
	if (argport(138, argc, argv)) ScanPort(138, "NetBIOS Datagram Service");
	// Scan for port 139 - netbios
	if (argport(139, argc, argv)) ScanPort(139, "NetBIOS Session Service");
	// Scan/data for port 143 - imap2
	if (argport(143, argc, argv)) ScanPortData(143, "Interim Mail Access Protocol 2");
	// Scan for port 201 - appletalk
	if (argport(201, argc, argv)) ScanPort(201, "AppleTalk Routing Maintenance");
	// Scan for port 202 - appletalk
	if (argport(202, argc, argv)) ScanPort(202, "AppleTalk Name Binding");
	// Scan for port 203 - appletalk
	if (argport(203, argc, argv)) ScanPort(203, "AppleTalk Unused");
	// Scan for port 204 - appletalk
	if (argport(204, argc, argv)) ScanPort(204, "AppleTalk Echo");
	// Scan for port 205 - appletalk
	if (argport(205, argc, argv)) ScanPort(205, "AppleTalk Unused");
	// Scan for port 206 - appletalk
	if (argport(206, argc, argv)) ScanPort(206, "AppleTalk Zone Information");
	// Scan for port 207 - appletalk
	if (argport(207, argc, argv)) ScanPort(207, "AppleTalk Unused");
	// Scan for port 208 - appletalk
	if (argport(208, argc, argv)) ScanPort(208, "AppleTalk Unused");
	// Scan/data for port 220 - imap3
	if (argport(220, argc, argv)) ScanPortData(220, "Interactive Mail Access Protocol 3");
	// Scan for port 512 - exec
	if (argport(512, argc, argv)) ScanPort(512, "exec");
	// Scan for port 513 - login
	if (argport(513, argc, argv)) ScanPort(513, "login");
	// Scan for port 514 - cmd
	if (argport(514, argc, argv)) ScanPort(514, "cmd");
	// Scan for port 515 - printer
	if (argport(515, argc, argv)) ScanPort(515, "printer");
	// Scan for port 517 - talk
	if (argport(517, argc, argv)) ScanPort(517, "talk");

	printf("\nScan Completed Successfully.\n");
}


